/*
 * $Id: lag.h,v 1.4 Broadcom SDK $
 *
 * $Copyright: Copyright 2015 Broadcom Corporation.
 * This program is the proprietary software of Broadcom Corporation
 * and/or its licensors, and may only be used, duplicated, modified
 * or distributed pursuant to the terms and conditions of a separate,
 * written license agreement executed between you and Broadcom
 * (an "Authorized License").  Except as set forth in an Authorized
 * License, Broadcom grants no license (express or implied), right
 * to use, or waiver of any kind with respect to the Software, and
 * Broadcom expressly reserves all rights in and to the Software
 * and all intellectual property rights therein.  IF YOU HAVE
 * NO AUTHORIZED LICENSE, THEN YOU HAVE NO RIGHT TO USE THIS SOFTWARE
 * IN ANY WAY, AND SHOULD IMMEDIATELY NOTIFY BROADCOM AND DISCONTINUE
 * ALL USE OF THE SOFTWARE.  
 *  
 * Except as expressly set forth in the Authorized License,
 *  
 * 1.     This program, including its structure, sequence and organization,
 * constitutes the valuable trade secrets of Broadcom, and you shall use
 * all reasonable efforts to protect the confidentiality thereof,
 * and to use this information only in connection with your use of
 * Broadcom integrated circuit products.
 *  
 * 2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS
 * PROVIDED "AS IS" AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES,
 * REPRESENTATIONS OR WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY,
 * OR OTHERWISE, WITH RESPECT TO THE SOFTWARE.  BROADCOM SPECIFICALLY
 * DISCLAIMS ANY AND ALL IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
 * NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE, LACK OF VIRUSES,
 * ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION OR
 * CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING
 * OUT OF USE OR PERFORMANCE OF THE SOFTWARE.
 * 
 * 3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL
 * BROADCOM OR ITS LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL,
 * INCIDENTAL, SPECIAL, INDIRECT, OR EXEMPLARY DAMAGES WHATSOEVER
 * ARISING OUT OF OR IN ANY WAY RELATING TO YOUR USE OF OR INABILITY
 * TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF
 * THE AMOUNT ACTUALLY PAID FOR THE SOFTWARE ITSELF OR USD 1.00,
 * WHICHEVER IS GREATER. THESE LIMITATIONS SHALL APPLY NOTWITHSTANDING
 * ANY FAILURE OF ESSENTIAL PURPOSE OF ANY LIMITED REMEDY.$
 *
 */

#ifndef _BOARDAPI_LAG_H_
#define _BOARDAPI_LAG_H_

#ifdef CFG_SWITCH_LAG_INCLUDED
#pragma pack(1)
typedef struct lag_group_s {
    uint8 enable;
	uint8 resp_port;
	uint8 fwd_port;
	pbmp_t cfg_lpbmp;
	pbmp_t hw_lpbmp;
} lag_group_t;
#pragma pack()

#define LAGID2TGID(x)   ((x) - 1)
#define TGID2LAGID(x)   ((x) + 1)
#define CFG_MAX_REGISTERED_LAGCHANGE    10

extern int board_lag_serializer_size_get(void) REENTRANT;

extern void board_lag_update_lacp_pbmp(uint16 uport, BOOL enable);
extern sys_error_t board_lag_set(uint8 enable) REENTRANT;
extern void board_lag_get(uint8 *enable) REENTRANT;
extern sys_error_t board_lag_mode_get(uint8 *mode);
extern sys_error_t board_lag_group_set(uint8 lagid,uint8 enable, uint8 *uplist, uint8 rtag) REENTRANT;
extern sys_error_t board_lag_group_get(uint8 lagid, 
                                    uint8 *enable, uint8 *uplist) REENTRANT;

extern void board_lag_group_max_num(uint8 *num) REENTRANT;
extern void board_lag_linkchange(uint16 uport, BOOL link, void *arg) REENTRANT;
extern int board_port_to_lag_group_get( uint16 uport, uint8 *tgid) REENTRANT;
extern uint8 board_lag_group_number_get(void);
extern int board_lag_respport_get(uint8 tgid, uint16* respport);
extern void board_lag_hwpbmp_get(uint8 tgid, pbmp_t *hwpbmp);
extern uint8 board_lag_hwpbmp_cnt(uint8 tgid);
extern sys_error_t board_lag_check_port(uint16 checkPort, uint8 *uplist);
extern sys_error_t board_lag_check_vlanid(uint8 *uplist) REENTRANT;

/* lag change registration/notification */
typedef void (*SYS_LAGCHANGE_FUNC)(uint8 lagid, uint8 enable, uint16 org_respport, uint8 *org_lplist, uint8 *new_lplist) REENTRANT;
extern void lagchange_init(void) REENTRANT;

#endif /* CFG_SWITCH_LAG_INCLUDED */

#endif /* _BOARDAPI_LAG_H_ */
